open Util
open Combinator

(** Polyhedrons (polytopes) *)

type optmodel =
  | Point of SMTProver.model
  | ExPoint of SMTProver.model * Term.t
  | Ray of SMTProver.model * SMTProver.model
  | Polytope of Formula.t * SMTProver.model
  | ExPolytope of Formula.t * SMTProver.model
let disable_ray = ref false
let enable_pol = ref false

let ext_convex_hull = ref (fun _ -> assert false : Formula.t -> Formula.t)
let convex_hull_dyn phi = !ext_convex_hull phi
let ext_widen_list = ref (fun _ -> assert false : Formula.t list -> Formula.t)
let widen_list_dyn phis = !ext_widen_list phis

let cast_to_int m =
  if List.for_all
      (fun (_, t) ->
         try
           let f = t |> RealTerm.float_of in
           f = float_of_int (Float.round f)
         with Not_found -> false)
      m
  then
    Some
      (List.map
         (fun (x, t) ->
            try
              x, t |> RealTerm.float_of |> Float.round |> IntTerm.make
            with Not_found -> assert false)
         m)
  else None
